'use strict';

exports.__esModule = true;
exports.default = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var $ = typeof $ === 'undefined' ? require('jquery') : $;

var Main = function (_Component) {
  _inherits(Main, _Component);

  function Main(props) {
    _classCallCheck(this, Main);

    var _this = _possibleConstructorReturn(this, _Component.call(this, props));

    console.log(props);
    // const sets = props.sets||{};
    _this.state = {
      num: '-',
      // start: sets.start,
      // end: sets.end,
      // lazy:sets.lazy
      start: props.start,
      end: props.end,
      lazy: props.lazy
    };
    _this.scroll = _this.scroll.bind(_this);
    return _this;
  }

  Main.prototype.componentDidMount = function componentDidMount() {
    var _this2 = this;

    if (this.state.lazy) {
      var debounce = this.debounce(100);
      $(window).scroll(function () {
        return debounce(_this2.scroll);
      }).trigger('scroll');
    } else {
      this.animate();
    }
  };

  Main.prototype.scroll = function scroll() {
    if ($(this.refs.rnum).offset().top < window.scrollY + window.screen.height) {
      this.setState({ lazy: false });
      this.animate();
    }
  };

  Main.prototype.debounce = function debounce(delay) {
    var timer = null;
    return function (fn) {
      var context = this;
      var args = arguments;
      clearTimeout(timer);
      timer = setTimeout(function () {
        fn.apply(context, args);
      }, delay);
    };
  };

  Main.prototype.componentWillReceiveProps = function componentWillReceiveProps(newprop) {
    var _this3 = this;

    if (newprop.end === this.state.end || this.state.lazy) return;
    this.setState(function (prevState) {
      return { end: newprop.end };
    }, function () {
      return _this3.animate();
    });
  };

  Main.prototype.format_number = function format_number(n) {
    var zhengshu = n >= 0;
    var b = Math.abs(~~n).toString();
    var len = b.length;
    if (len <= 3) {
      return ~~n;
    }
    var r = len % 3;
    var result = b.slice(0, r) + "," + b.slice(r, len).match(/\d{3}/g).join(",");
    if (result.startsWith(',')) {
      result = result.substring(1);
    }
    return zhengshu ? result : '-' + result;
  };

  Main.prototype.animate = function animate() {
    var _this4 = this;

    // const sets = this.props.sets || {};
    var _props = this.props,
        _props$duration = _props.duration,
        duration = _props$duration === undefined ? 1000 : _props$duration,
        _props$easing = _props.easing,
        easing = _props$easing === undefined ? 'swing' : _props$easing,
        _props$format = _props.format,
        format = _props$format === undefined ? false : _props$format,
        _props$dot = _props.dot,
        dot = _props$dot === undefined ? 0 : _props$dot;

    var start = this.state.start || 0;
    var end = this.state.end === 0 ? 0 : this.state.end || start;
    $(this).attr('nums', start).animate({
      nums: end
    }, {
      duration: duration,
      easing: easing,
      step: function step(re) {
        var nu = re.toFixed(dot);
        var num = format ? _this4.format_number(nu) : nu;

        // if(format&&sets.dot){
        //   console.log(re.toFixed(sets.dot),sets.dot)
        //   num = (+(re.toFixed(sets.dot))).toLocaleString()
        // }
        _this4.setState({ start: re, num: num });
        // this.setState(prev=>({
        //   start:re,
        //   num
        // }))
      }
    });
  };

  Main.prototype.render = function render() {
    return _react2.default.createElement(
      'span',
      { ref: 'rnum', id: this.props.id, className: this.props.className },
      this.state.num
    );
  };

  return Main;
}(_react.Component);

exports.default = Main;


_react.Component.propTypes = {
  className: _propTypes2.default.string,
  id: _propTypes2.default.string,
  start: _propTypes2.default.number,
  duration: _propTypes2.default.number,
  end: _propTypes2.default.number,
  easing: _propTypes2.default.oneOf(['easing', 'linear']),
  format: _propTypes2.default.bool,
  dot: _propTypes2.default.number,
  lazy: _propTypes2.default.bool
};
module.exports = exports['default'];